;Copyright (c) 2008 Sysop Scripts

;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
;
; Script Name:    Print Directory Feature
; Version:        1.0
; Language:       English
; Platform:       WinXP/Vista
; Author:         Sysop Scripts
;
;
; Script Function:
;	This script adds or removes the print directory feature from Microsoft Article 321379.
;

#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input ; Recommended for new scripts due to its superior speed and reliability.
#SingleInstance force ;Only one instance of script at a time
#NoTrayIcon ;Removes tray icon display
#EscapeChar ` ;Escape character

; Check for administrator rights which are needed to make these changes before proceeding

If A_IsAdmin = 1
    Goto, IsAdmin
Else
{
    MsgBox, 16, Oops!, You must have administrator rights on this system to run this utility!
    ExitApp
}

IsAdmin:
Sleep, 100

Gui, Add, Button, x16 y17 w180 h50 gAdd, &Add Print Directory Feature
Gui, Add, Button, x16 y87 w180 h50 gRemove, &Remove Print Directory Feature
Gui, Add, Button, x96 y157 w100 h30 gCancel, &Cancel
Gui, Add, Text, x16 y197 w180 h40 +Center, Print Directory Feature Utility v1.0`nWin XP/Vista - Sysop Scripts`nMS Article 321379
Gui, Show, x131 y91 h250 w218, Print Directory Feature
Return

Add:
;Create the printdir.bat file in the systems windows directory for calling
FileAppend, `@echo off`ndir `%1 /-p /o:gn > "`%temp`%\Listing"`nstart /w notepad /p "`%temp`%\Listing"`ndel "`%temp`%\Listing"`nexit, %A_WinDir%\printdir.bat
If ErrorLevel = 1
{
    MsgBox, 16, File Creation Error, There was an error creating the PrintDir.bat file.
    ExitApp
}
Else
    Goto, PrintDirOK
    
PrintDirOk:
Sleep, 100

;Add three registry keys and values to the registry
RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Directory\shell\none, , 
RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Directory\shell\Print_Directory_Listing, , Print Directory Listing
RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Directory\shell\Print_Directory_Listing\command, , printdir.bat
If ErrorLevel = 1
{
    MsgBox, 16, Registry Key Error, There was an error creating the needed registry keys.
    ExitApp
}
Else
    Goto, RegKeyOK
    
RegKeyOk:
Sleep, 100

MsgBox, 64, Success, Print Directory Feature was sucessfully configured!

ExitApp

Remove:
;Delete the printdir.bat file from the systems windows directory
FileDelete, %A_WinDir%\printdir.bat
If ErrorLevel = 1
{
    MsgBox, 16, File Deletion Error, There was an error deleting the PrintDir.bat file from the system Windows directory.
}
Else
    Goto, DelPrintDirOK
    
DelPrintDirOk:
Sleep, 100

;Delete three registry keys and values to the registry
RegDelete, HKEY_CLASSES_ROOT, Directory\shell\Print_Directory_Listing\command,
RegDelete, HKEY_CLASSES_ROOT, Directory\shell\Print_Directory_Listing,
RegDelete, HKEY_CLASSES_ROOT, Directory\shell\none, 
If ErrorLevel = 1
{
    MsgBox, 16, Registry Key Error, There was an error deleting the installed registry keys.
}
Else
    Goto, DelRegKeyOK
    
DelRegKeyOk:
Sleep, 100

MsgBox, 64, Success, Print Directory Feature was sucessfully removed!

ExitApp

Cancel:
ExitApp

GuiClose:
ExitApp